// fbset -depth 16 -n
// colormap = 5R, 5G, 5B
// bien penser a sync quand on sauve un fichier

#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <linux/fb.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>

// #include <mathf.h>

char * device = "/dev/fb0";

struct fb_var_screeninfo screeninfo;
int screen_fd;
unsigned short * screen_ptr;
int screen_width;
int screen_height;

inline void draw_pixel(int x, int y, int color)
{
	unsigned short *loc = screen_ptr + \
	   ((y + screeninfo.yoffset) * screen_width ) + x + screeninfo.xoffset;
	
	if ((x<0) || (x>=screen_width) || (y<0) || (y>=screen_height))
		return;
        *loc = color;    // 5R, 5G, 5B
	*loc |= 1 << 15; // transparence ?
}

void draw_ppm(char *nom)
{FILE *f;
 int x,y,sx,sy,bpp;char s[255],r,g,b;
 f=fopen(nom,"r");
 fscanf(f,"%s",s);
 fscanf(f,"%d",&sx);
 fscanf(f,"%d",&sy);
 fscanf(f,"%d",&bpp);
 fscanf(f,"%c",&r);   // retour chariot additionel
 for (y=0;y<sy;y++)
   for (x=0;x<sx;x++) {
     fscanf(f,"%c",&r); fscanf(f,"%c",&g); fscanf(f,"%c",&b);
     bpp=(((int)(r&0xf8))>>3)+(((int)(g&0xf8))<<2)+(((int)(b&0xf8))<<8);
     draw_pixel(x, y, bpp);
   }
 fclose(f);
}

void draw_lissajous(void)
{int x=0;
 volatile int y;
 int *tableau,*oldtableau;
 FILE *f;

 f=fopen("sortie.dat","w");

 tableau=(int*)malloc(screen_width*sizeof(int));
 oldtableau=(int*)malloc(screen_width*sizeof(int));

// while (1)
   {for (x=0;x<screen_width;x++)
      {*(unsigned short*)(0x8000000)=(unsigned short)0;
       for (y=0;y<5;y++) {} // usleep(1);
       tableau[x]=*(unsigned short*)(0x8000000)&0xff;
      }
    for (x=0;x<screen_width;x++) draw_pixel(x, oldtableau[x], 0);
    for (x=0;x<screen_width;x++) {
        fprintf(f,"%d\n",tableau[x]);fflush(f);
        draw_pixel(x, tableau[x], 0xFFFF);
	oldtableau[x]=tableau[x];
       }
   }
   fclose(f);
}

int main(int argc, char *argv[])
{       char c;
	screen_fd = open(device, O_RDWR);
	if (screen_fd == -1) {
		perror("Unable to open frame buffer device /dev/fb0");
		exit(0);
	}
	
	if (ioctl(screen_fd, FBIOGET_VSCREENINFO, &screeninfo)==-1) {
		perror("Unable to retrieve framebuffer information");
		exit(0);
	}

	screen_width = screeninfo.xres;
	screen_height = screeninfo.yres;
	
	screen_ptr = mmap(0, screen_height * screen_width / 8, PROT_READ|PROT_WRITE, MAP_SHARED, screen_fd, 0);
	
	if (screen_ptr==MAP_FAILED) 
	   perror("Unable to mmap frame buffer");
	
	if (argc==1) draw_lissajous(); else draw_ppm(argv[1]);

        scanf("%c",&c);
	close(screen_fd);
	
	return 0;
}
